s_a_noun(man).
s_a_noun(woman).
s_a_noun(boy).
s_a_noun(girl).
s_a_noun(dog).
s_a_noun(cat).

p_a_noun(men).
p_a_noun(women).
p_a_noun(boys).
p_a_noun(girls).
p_a_noun(dogs).
p_a_noun(cats).

s_i_noun(ball).
s_i_noun(doll).
s_i_noun(stick).

p_i_noun(balls).
p_i_noun(dolls).
p_i_noun(sticks).

s_t_verb(chase).
s_t_verb(kiss).
s_t_verb(throw).

p_t_verb(chases).
p_t_verb(kisses).
p_t_verb(throws).

s_i_verb(run).
s_i_verb(walk).

p_i_verb(runs).
p_i_verb(walks).

s_qtifier(a).
s_qtifier(every).
p_qtifier(some).
p_qtifier(all).

s_noun_phrase(X, Y) :- s_qtifier(X), s_i_noun(Y).
s_noun_phrase(X, Y) :- s_qtifier(X), s_a_noun(Y).
p_noun_phrase(X, Y) :- p_qtifier(X), p_i_noun(Y).
p_noun_phrase(X, Y) :- p_qtifier(X), p_a_noun(Y).

noun_phrase(X, Y) :- s_noun_phrase(X, Y).
noun_phrase(X, Y) :- p_noun_phrase(X, Y).

s_t_verb_phrase(X, Y, Z) :- s_t_verb(X), s_noun_phrase(Y, Z).
s_t_verb_phrase(X, Y, Z) :- s_t_verb(X), p_noun_phrase(Y, Z).
p_t_verb_phrase(X, Y, Z) :- p_t_verb(X), s_noun_phrase(Y, Z).
p_t_verb_phrase(X, Y, Z) :- p_t_verb(X), p_noun_phrase(Y, Z).

t_verb_phrase(X, Y, Z) :- ss_t_verb_phrase(X, Y, Z).
t_verb_phrase(X, Y, Z) :- sp_t_verb_phrase(X, Y, Z).
t_verb_phrase(X, Y, Z) :- ps_t_verb_phrase(X, Y, Z).
t_verb_phrase(X, Y, Z) :- pp_t_verb_phrase(X, Y, Z).

t_sentence(V, W, X, Y, Z) :- s_noun_phrase(V, W), p_t_verb_phrase(X, Y, Z).
t_sentence(V, W, X, Y, Z) :- p_noun_phrase(V, W), s_t_verb_phrase(X, Y, Z).

i_sentence(X, Y, Z) :- s_noun_phrase(X, Y), p_i_verb(Z).
i_sentence(X, Y, Z) :- p_noun_phrase(X, Y), s_i_verb(Z).

sentence(V, W, X, Y, Z) :- t_sentence(V, W, X, Y, Z).
sentence(X, Y, Z) :- i_sentence(X, Y, Z).

